package com.sksamuel.kotlintest.specs.describe

import io.kotlintest.shouldBe
import io.kotlintest.specs.DescribeSpec

class DescribeSpecLambdaTest : DescribeSpec({

  var name: String? = null

  describe("context 1") {
    it("the name should start off null") {
      name.shouldBe(null)
    }
    name = "foo"
    context("the name should be foo in this context") {
      name.shouldBe("foo")
      it("should still be foo for this nested test") {
        name.shouldBe("foo")
      }
      name = "boo"
      it("now the name should be boo") {
        name.shouldBe("boo")
      }
    }
    it("it should still be boo as this test should run after all the above") {
      name.shouldBe("boo")
    }
    name = "koo"
    it("now the name should be set to koo") {
      name.shouldBe("koo")
    }
  }

  describe("context 2 should run after context 1") {
    it("name should still be the last value which was koo") {
      name shouldBe "koo"
    }
  }
})